package com.zt.plat.module.qms.resource.material.service;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialUseEndReuseDetailPageReqVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialUseEndReuseDetailRespVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialUseEndReuseDetailSaveReqVO;
import com.zt.plat.module.qms.resource.material.dal.dataobject.MaterialProductDO;
import com.zt.plat.module.qms.resource.material.dal.dataobject.MaterialUseEndReuseDetailDO;
import com.zt.plat.module.qms.resource.material.dal.mapper.MaterialUseEndReuseDetailMapper;
import jakarta.annotation.Resource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import java.util.List;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.MATERIAL_USE_END_REUSE_DETAIL_NOT_EXISTS;

/**
 * 物料用完标记或清洗回收明细 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class MaterialUseEndReuseDetailServiceImpl implements MaterialUseEndReuseDetailService {

    @Resource
    private MaterialUseEndReuseDetailMapper materialUseEndReuseDetailMapper;

    @Autowired
    private MaterialProductService materialProductService;

    @Override
    public MaterialUseEndReuseDetailRespVO createMaterialUseEndReuseDetail(MaterialUseEndReuseDetailSaveReqVO createReqVO) {
        // 插入
        MaterialUseEndReuseDetailDO materialUseEndReuseDetail = BeanUtils.toBean(createReqVO, MaterialUseEndReuseDetailDO.class);
        materialUseEndReuseDetailMapper.insert(materialUseEndReuseDetail);
        // 返回
        return BeanUtils.toBean(materialUseEndReuseDetail, MaterialUseEndReuseDetailRespVO.class);
    }

    @Override
    public void updateMaterialUseEndReuseDetail(MaterialUseEndReuseDetailSaveReqVO updateReqVO) {
        // 校验存在
        validateMaterialUseEndReuseDetailExists(updateReqVO.getId());
        // 更新
        MaterialUseEndReuseDetailDO updateObj = BeanUtils.toBean(updateReqVO, MaterialUseEndReuseDetailDO.class);
        materialUseEndReuseDetailMapper.updateById(updateObj);
    }

    @Override
    public void deleteMaterialUseEndReuseDetail(Long id) {
        // 校验存在
        validateMaterialUseEndReuseDetailExists(id);
        // 删除
        materialUseEndReuseDetailMapper.deleteById(id);
    }

    @Override
        public void deleteMaterialUseEndReuseDetailListByIds(List<Long> ids) {
        // 校验存在
        validateMaterialUseEndReuseDetailExists(ids);
        // 删除
        materialUseEndReuseDetailMapper.deleteByIds(ids);
        }

    private void validateMaterialUseEndReuseDetailExists(List<Long> ids) {
        List<MaterialUseEndReuseDetailDO> list = materialUseEndReuseDetailMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(MATERIAL_USE_END_REUSE_DETAIL_NOT_EXISTS);
        }
    }

    private void validateMaterialUseEndReuseDetailExists(Long id) {
        if (materialUseEndReuseDetailMapper.selectById(id) == null) {
            throw exception(MATERIAL_USE_END_REUSE_DETAIL_NOT_EXISTS);
        }
    }

    @Override
    public MaterialUseEndReuseDetailDO getMaterialUseEndReuseDetail(Long id) {
        return materialUseEndReuseDetailMapper.selectById(id);
    }

    @Override
    public PageResult<MaterialUseEndReuseDetailDO> getMaterialUseEndReuseDetailPage(MaterialUseEndReuseDetailPageReqVO pageReqVO) {
        return materialUseEndReuseDetailMapper.selectPage(pageReqVO);
    }

    @Override
    public void saveBatch(List<MaterialUseEndReuseDetailDO> detailDOS) {
        materialUseEndReuseDetailMapper.insertBatch(detailDOS);
    }

    @Override
    public PageResult<MaterialUseEndReuseDetailRespVO> getDetailPageWithParentInfoAndMaterialInfo(MaterialUseEndReuseDetailPageReqVO pageReqVO) {
        Long productId = pageReqVO.getProductId();
        PageResult<MaterialUseEndReuseDetailRespVO> pageResult;
        if (productId == null) {
            pageResult = materialUseEndReuseDetailMapper.selectPageWithParentInfoAndMaterialInfo(pageReqVO, null);
        } else {
            List<MaterialProductDO> products = materialProductService.getMaterialProductsByLikeIdPath(productId);
            if (CollUtil.isEmpty(products))
                return materialUseEndReuseDetailMapper.selectPageWithParentInfoAndMaterialInfo(pageReqVO, null);
            List<Long> pdtIds = products.stream().map(MaterialProductDO::getId).toList();
            pageResult = materialUseEndReuseDetailMapper.selectPageWithParentInfoAndMaterialInfo(pageReqVO, pdtIds);
        }
        return pageResult;
    }

    @Override
    public List<MaterialUseEndReuseDetailRespVO> getDetailRespVOSByParentIds(List<Long> parentIds) {
        return materialUseEndReuseDetailMapper.selectListWithParentInfoAndMaterialInfoByParentIds(parentIds);
    }

    @Override
    public void deleteDetailListByParentId(Long id) {
        materialUseEndReuseDetailMapper.delete(MaterialUseEndReuseDetailDO::getParentId, id);
    }

    @Override
    public void deleteDetailListByParentIds(List<Long> parentIds) {
        materialUseEndReuseDetailMapper.deleteBatch(MaterialUseEndReuseDetailDO::getParentId, parentIds);
    }

    @Override
    public List<MaterialUseEndReuseDetailDO> getDetailListByIds(List<Long> detailIds) {
        return materialUseEndReuseDetailMapper.selectByIds(detailIds);
    }

    @Override
    public void updateByIds(List<Long> detailIds, MaterialUseEndReuseDetailDO detailDO) {
        materialUseEndReuseDetailMapper.update(detailDO, Wrappers.lambdaQuery(MaterialUseEndReuseDetailDO.class)
                .in(MaterialUseEndReuseDetailDO::getId, detailIds));

    }

}